import { Mark, Node } from "../../tiptap/Utils";
import { nodeInputRule, wrappingInputRule } from "../../commands";

export default class KunUrl extends Node {
  get name() {
    return "url";
  }

  get schema() {
    return {
      inline: true,
      group: "inline",
      atom: true,
      draggable: true,
      attrs: {
        title: {
        },
        url: {
        },
      },
      toDOM: (node) => ["kun-ex-link", node.attrs],
      parseDOM: [
        {
          tag: "kun-ex-link",
          getAttrs: (dom) => ({
            url: dom.getAttribute("url"),
            title: dom.getAttribute("title"),
          }),
        },
      ],
    };
  }

  // get schema() {
  //   return {
  //     // content: "inline*",
  //     group: "inline",
  //     inline: true,
  //     // group: "block",
  //     // defining: true,
  //     draggable: false,
  //     attrs: {
  //       iconType: {
  //         default: "comment",
  //       },
  //       iconWidth: {
  //         default: 16,
  //       },
  //       iconHeight: {
  //         default: 16,
  //       },
  //     },
  //     // parseDOM: [
  //     //   { tag: "kun-icon" },
  //     // ],
  //     parseDOM: [{
  //       tag: "kun-icon",
  //       getAttrs: (dom) => {
  //         const type = dom.getAttribute("iconType");
  //         if (type != null) {
  //           return {
  //             iconType: type,
  //           };
  //         }
  //         return false;
  //       },
  //     }],
  //     toDOM: (node) => ["kun-icon", {...node.attrs,
  //       iconType: "content",
  //       iconWidth: 18,
  //       iconHeight: 18,
  //     }, 0],
  //   };
  // }

  commands({ type }) {
    console.log("commands iconp");
    console.log(`commands iconp ${type}`, type);
    return (attrs) => (state, dispatch) => {
      const { selection } = state;
      const position = selection.$cursor ? selection.$cursor.pos : selection.$to.pos;
      const node = type.create(attrs);
      const transaction = state.tr.insert(position, node);
      dispatch(transaction);
    };
  }
}
